;; $Id: dbgraph.dsl,v 1.1.1.2 1998/06/13 14:57:34 rosalia Exp $
;;
;; This file is part of the Modular DocBook Stylesheet distribution.
;; See ../README or http://www.berkshire.net/~norm/dsssl/
;;

;; ==================== GRAPHICS ====================

(define (graphic-file filename)
  (let ((ext (file-extension filename)))
    (if (or (not filename)
	    (not %graphic-default-extension%)
	    (member ext %graphic-extensions%))
	filename
	(string-append filename "." %graphic-default-extension%))))

(define ($img$ #!optional (nd (current-node)) (alt #f))
  (let* ((fileref (attribute-string (normalize "fileref") nd))
	 (entattr (attribute-string (normalize "entityref") nd))
	 (entityref (if entattr
			(entity-system-id entattr)
			#f))
	 (format  (attribute-string (normalize "format")))
	 (align   (attribute-string (normalize "align")))
	 (attr    (append 
		   (if align 
		       (list (list "ALIGN" align)) 
		       '())
		   (if entityref
		       (list (list "SRC" (graphic-file entityref)))
		       (list (list "SRC" (graphic-file fileref))))
		   (if alt
		       (list (list "ALT" alt))
		       '()))))
    (if (or fileref entityref) 
	(make empty-element gi: "IMG"
	      attributes: attr)
	(empty-sosofo))))

(element graphic
  (make element gi: "P"
	($img$)))

(element inlinegraphic
  ($img$))
