;; $Id: dbgraph.dsl,v 1.1.1.2 1998/06/13 14:56:16 rosalia Exp $
;;
;; This file is part of the Modular DocBook Stylesheet distribution.
;; See ../README or http://www.berkshire.net/~norm/dsssl/
;;

;; ==================== GRAPHICS ====================

;; NOTE: display #f doesn't seem to work right in the RTF back end...


(define (graphic-file filename)
  (let ((ext (file-extension filename)))
    (if (or (not filename)
	    (not %graphic-default-extension%)
	    (member ext %graphic-extensions%))
	filename
	(string-append filename "." %graphic-default-extension%))))

(define ($img$ #!optional (nd (current-node)) (display #f))
  (let ((fileref (attribute-string (normalize "fileref") nd))
	(entityref (attribute-string (normalize "entityref") nd))
	(format (attribute-string (normalize "format") nd))
	(align (attribute-string (normalize "align") nd))
	(scale (attribute-string (normalize "scale") nd)))
    (if (or fileref entityref) 
	(make external-graphic
	  notation-system-id: (if format format "")
	  entity-system-id: (if fileref 
				(graphic-file fileref)
				(if entityref 
				    (graphic-file 
				     (entity-generated-system-id entityref))
				    ""))
	  scale: (if scale (/  (string->number scale) 100) 100)
	  display?: display
	  display-alignment: (cond ((equal? align (normalize "center")) 'center)
				   ((equal? align (normalize "right")) 'end)
				   (else 'start)))
	(empty-sosofo))))

(element graphic
  (make paragraph
    space-before: %block-sep%
    space-after: %block-sep%
    ($img$ (current-node) #t)))

(element inlinegraphic ($img$))


